
# P1

def justEvens(d):
    even_keys = []
    for k in d:
        if d[k] % 2 == 0:
            even_keys.append(k)
    return even_keys


# P2

dollars = int(input("Enter an amount in dollars: "))
fives = dollars // 5
ones = dollars % 5
s = ""
if fives > 0:
    s += str(fives) + " five"
    if fives > 1:
        s += "s"
if ones > 0:
    if fives > 0:
        s += " "
    s += str(ones) + " one"
    if ones > 1:
        s += "s"
print(s)

# P3

class Node:
    
    def __init__(self, value):
        self.value = value
        self.next = None
        
class LinkedList:
    
    def __init__(self):
        self.first = None

    def prepend(self, value):
        newNode = Node(value)
        newNode.next = self.first
        self.first = newNode

    def output(self):
        current = self.first
        while current is not None:
            print(current.value)
            current = current.next

    def appendSeveral(self, value, times):
        if times > 0 and self.first is None:
            self.first = Node(value)
            times -= 1
        current = self.first
        while current.next is not None:
            current = current.next
        while times > 0:
            current.next = Node(value)
            current = current.next
            times -= 1

# P4

def pairQuery(first, second):
    def query(which):
        if which == "first":
            return first
        else:
            return second

# P5

class Animal:
      
    def __init__(self, id, species):
        self.id = id
        self.species = species
        self.hunger = 0
        self.energy = 100
        self.asleep = False
          
    def update(self):
        if self.asleep:
            self.energy += 1
            if self.energy >= 100:
                self.asleep = False
        else:
            self.energy -= 1
            if self.energy <= 0:
                self.asleep = True

    def eat(self, amount):
        if self.asleep:
            self.asleep = False
        self.hunger = max(0,self.hinger - amount)

    
class Elephant(Animal):
    
    def __init__(self,id):
        super().__init__(id,'elephant')

    def eat(self, amount):
        if not self.asleep:
            super().eat(amount)

# P6

def position_of(value, consecs):
    # binary search; assumes value is in consecs
    left = 0
    right = len(consecs) - 1
    while True:
        middle = (left + right) // 2
        if consecs[middle] == value:
            return middle
        elif value < consecs[middle]:
            right = middle - 1
        else:
            left = middle + 1

def occurs_in_consecutives(consecs, value):
    before = position_of(value - 1, consecs)
    after = position_of(value + 1, consecs)
    return after - before - 1

# P7

def reverse(bits):
    flipped = []
    for bit in bits:
        if bit == '0':
            flipped.append('1')
        else:
            flipped.append('0')
    return flipped
        
def reverseBitMap(infile, outfile):
    fin = open(infile, "r")
    fout = open(outfile, "w")
    fout.write(fin.readline())
    for line in fin:
        fout.write(' '.join(reverse(line.rstrip().split(' '))) + '\n')
    fin.close()
    fout.close()

# P8

# NOTE: the code below is not valid. there are HTTP and URL modules in Python
#       for fetching data. This problem invents a fictional one.

"""
import http
                   
def webPageAvailable(url, attempts):
    while attempts > 0:
        try:
            contents = http.fetchURL(url)
            return True
        except http.TimeoutException:
            attempts -= 1
        except http.NotFound
            return False
    return False
"""

# P9

class BSTNode:

    def __init__(self, key, value):
        self.key = key
        self.value = value
        self.left = None
        self.right = None
        
class BSTree:

    def __init_(self):
        self.root = None

    def sumValues(self):
        
        def subtreeSum(node):
            if node is None:
                return 0
            else:
                lsum = subtreeSum(node.left)
                rsum = subtreeSum(node.right)
                return lsum + node.value + rsum

        return subtreeSum(self.root)

# P10

# a) This code runs in Theta(n) time.

# b) This code runs in Theta(n^2) time.

# c) This code runs in Theta(log(n)) time.

# d) This code runs in Theta(n log(n)) time.




